/*
Copyright The Kubernetes Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by informer-gen. DO NOT EDIT.

package v1

import (
	"context"
	time "time"

	danmv1 "github.com/nokia/danm/crd/apis/danm/v1"
	versioned "github.com/nokia/danm/crd/client/clientset/versioned"
	internalinterfaces "github.com/nokia/danm/crd/client/informers/externalversions/internalinterfaces"
	v1 "github.com/nokia/danm/crd/client/listers/danm/v1"
	metav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	runtime "k8s.io/apimachinery/pkg/runtime"
	watch "k8s.io/apimachinery/pkg/watch"
	cache "k8s.io/client-go/tools/cache"
)

// TenantNetworkInformer provides access to a shared informer and lister for
// TenantNetworks.
type TenantNetworkInformer interface {
	Informer() cache.SharedIndexInformer
	Lister() v1.TenantNetworkLister
}

type tenantNetworkInformer struct {
	factory          internalinterfaces.SharedInformerFactory
	tweakListOptions internalinterfaces.TweakListOptionsFunc
	namespace        string
}

// NewTenantNetworkInformer constructs a new informer for TenantNetwork type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewTenantNetworkInformer(client versioned.Interface, namespace string, resyncPeriod time.Duration, indexers cache.Indexers) cache.SharedIndexInformer {
	return NewFilteredTenantNetworkInformer(client, namespace, resyncPeriod, indexers, nil)
}

// NewFilteredTenantNetworkInformer constructs a new informer for TenantNetwork type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewFilteredTenantNetworkInformer(client versioned.Interface, namespace string, resyncPeriod time.Duration, indexers cache.Indexers, tweakListOptions internalinterfaces.TweakListOptionsFunc) cache.SharedIndexInformer {
	return cache.NewSharedIndexInformer(
		&cache.ListWatch{
			ListFunc: func(options metav1.ListOptions) (runtime.Object, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.DanmV1().TenantNetworks(namespace).List(context.TODO(), options)
			},
			WatchFunc: func(options metav1.ListOptions) (watch.Interface, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.DanmV1().TenantNetworks(namespace).Watch(context.TODO(), options)
			},
		},
		&danmv1.TenantNetwork{},
		resyncPeriod,
		indexers,
	)
}

func (f *tenantNetworkInformer) defaultInformer(client versioned.Interface, resyncPeriod time.Duration) cache.SharedIndexInformer {
	return NewFilteredTenantNetworkInformer(client, f.namespace, resyncPeriod, cache.Indexers{cache.NamespaceIndex: cache.MetaNamespaceIndexFunc}, f.tweakListOptions)
}

func (f *tenantNetworkInformer) Informer() cache.SharedIndexInformer {
	return f.factory.InformerFor(&danmv1.TenantNetwork{}, f.defaultInformer)
}

func (f *tenantNetworkInformer) Lister() v1.TenantNetworkLister {
	return v1.NewTenantNetworkLister(f.Informer().GetIndexer())
}
